diff --git a/lib/librte_eal/bsdapp/contigmem/contigmem.c b/lib/librte_eal/bsdapp/contigmem/contigmem.c
index 6634daa..8ac836d 100644
--- a/lib/librte_eal/bsdapp/contigmem/contigmem.c
+++ b/lib/librte_eal/bsdapp/contigmem/contigmem.c
@@ -230,4 +230,3 @@ contigmem_mmap_single(struct cdev *cdev, vm_ooffset_t *offset, vm_size_t size,
 
 	return (0);
 }
-
diff --git a/lib/librte_eal/bsdapp/eal/Makefile b/lib/librte_eal/bsdapp/eal/Makefile
index 3d1d9eb..c73ffb6 100644
--- a/lib/librte_eal/bsdapp/eal/Makefile
+++ b/lib/librte_eal/bsdapp/eal/Makefile
@@ -99,4 +99,3 @@ SYMLINK-$(CONFIG_RTE_LIBRTE_EAL_BSDAPP)-include/exec-env := \
 DEPDIRS-$(CONFIG_RTE_LIBRTE_EAL_BSDAPP) += lib/librte_eal/common
 
 include $(RTE_SDK)/mk/rte.lib.mk
-
diff --git a/lib/librte_eal/bsdapp/eal/eal.c b/lib/librte_eal/bsdapp/eal/eal.c
index 43e8a47..7bd392f 100644
--- a/lib/librte_eal/bsdapp/eal/eal.c
+++ b/lib/librte_eal/bsdapp/eal/eal.c
@@ -569,4 +569,3 @@ rte_eal_process_type(void)
 {
 	return (rte_config.process_type);
 }
-
diff --git a/lib/librte_eal/bsdapp/eal/eal_interrupts.c b/lib/librte_eal/bsdapp/eal/eal_interrupts.c
index cb7d4f1..26a55c7 100644
--- a/lib/librte_eal/bsdapp/eal/eal_interrupts.c
+++ b/lib/librte_eal/bsdapp/eal/eal_interrupts.c
@@ -68,4 +68,3 @@ rte_eal_intr_init(void)
 {
 	return 0;
 }
-
diff --git a/lib/librte_eal/common/eal_common_hexdump.c b/lib/librte_eal/common/eal_common_hexdump.c
index 6135133..d5cbd70 100644
--- a/lib/librte_eal/common/eal_common_hexdump.c
+++ b/lib/librte_eal/common/eal_common_hexdump.c
@@ -103,7 +103,7 @@ rte_memdump(FILE *f, const char * title, const void * buf, unsigned int len)
 
     line[0] = '\0';
     for (i = 0, out = 0; i < len; i++) {
-    	// Make sure we do not overrun the line buffer length.
+	// Make sure we do not overrun the line buffer length.
 		if ( out >= (LINE_LEN - 4) ) {
 			fprintf(f, "%s", line);
 			out = 0;
@@ -118,4 +118,3 @@ rte_memdump(FILE *f, const char * title, const void * buf, unsigned int len)
 
     fflush(f);
 }
-
diff --git a/lib/librte_eal/common/eal_common_launch.c b/lib/librte_eal/common/eal_common_launch.c
index 152d1c3..229c3a0 100644
--- a/lib/librte_eal/common/eal_common_launch.c
+++ b/lib/librte_eal/common/eal_common_launch.c
@@ -116,4 +116,3 @@ rte_eal_mp_wait_lcore(void)
 		rte_eal_wait_lcore(lcore_id);
 	}
 }
-
diff --git a/lib/librte_eal/common/eal_common_log.c b/lib/librte_eal/common/eal_common_log.c
index fe3d7d5..c903aa9 100644
--- a/lib/librte_eal/common/eal_common_log.c
+++ b/lib/librte_eal/common/eal_common_log.c
@@ -331,4 +331,3 @@ rte_eal_common_log_init(FILE *default_log)
 	rte_openlog_stream(default_log);
 	return 0;
 }
-
diff --git a/lib/librte_eal/common/include/generic/rte_cycles.h b/lib/librte_eal/common/include/generic/rte_cycles.h
index 7700f41..8cc21f2 100644
--- a/lib/librte_eal/common/include/generic/rte_cycles.h
+++ b/lib/librte_eal/common/include/generic/rte_cycles.h
@@ -130,12 +130,12 @@ rte_get_hpet_hz(void);
  * then the HPET functions are unavailable and should not be called.
  *
  * @param make_default
- * 	If set, the hpet timer becomes the default timer whose values are
- * 	returned by the rte_get_timer_hz/cycles API calls
+ *	If set, the hpet timer becomes the default timer whose values are
+ *	returned by the rte_get_timer_hz/cycles API calls
  *
  * @return
- * 	0 on success,
- * 	-1 on error, and the make_default parameter is ignored.
+ *	0 on success,
+ *	-1 on error, and the make_default parameter is ignored.
  */
 int rte_eal_hpet_init(int make_default);
 
diff --git a/lib/librte_eal/common/include/rte_hexdump.h b/lib/librte_eal/common/include/rte_hexdump.h
index 891c77b..5c18a50 100644
--- a/lib/librte_eal/common/include/rte_hexdump.h
+++ b/lib/librte_eal/common/include/rte_hexdump.h
@@ -49,15 +49,15 @@ extern "C" {
 * Dump out memory in a special hex dump format.
 *
 * @param f
-*   		A pointer to a file for output
+*		A pointer to a file for output
 * @param title
-* 		If not NULL this string is printed as a header to the output.
+*		If not NULL this string is printed as a header to the output.
 * @param buf
-* 		This is the buffer address to print out.
+*		This is the buffer address to print out.
 * @param len
-* 		The number of bytes to dump out
+*		The number of bytes to dump out
 * @return
-* 		None.
+*		None.
 */
 
 extern void
@@ -67,15 +67,15 @@ rte_hexdump(FILE *f, const char * title, const void * buf, unsigned int len);
 * Dump out memory in a hex format with colons between bytes.
 *
 * @param f
-*   		A pointer to a file for output
+*		A pointer to a file for output
 * @param title
-* 		If not NULL this string is printed as a header to the output.
+*		If not NULL this string is printed as a header to the output.
 * @param buf
-* 		This is the buffer address to print out.
+*		This is the buffer address to print out.
 * @param len
-* 		The number of bytes to dump out
+*		The number of bytes to dump out
 * @return
-* 		None.
+*		None.
 */
 
 void
diff --git a/lib/librte_eal/common/include/rte_interrupts.h b/lib/librte_eal/common/include/rte_interrupts.h
index 609c34b..ff11ef3 100644
--- a/lib/librte_eal/common/include/rte_interrupts.h
+++ b/lib/librte_eal/common/include/rte_interrupts.h
@@ -118,4 +118,3 @@ int rte_intr_disable(struct rte_intr_handle *intr_handle);
 #endif
 
 #endif
-
diff --git a/lib/librte_eal/common/include/rte_memory.h b/lib/librte_eal/common/include/rte_memory.h
index 7f8103f..d948c0b 100644
--- a/lib/librte_eal/common/include/rte_memory.h
+++ b/lib/librte_eal/common/include/rte_memory.h
@@ -196,7 +196,7 @@ phys_addr_t rte_mem_phy2mch(uint32_t memseg_id, const phys_addr_t phy_addr);
  *
  * @return
  *       0: successfully
- *    	 negative: error
+ *	 negative: error
  */
 int rte_xen_dom0_memory_init(void);
 
diff --git a/lib/librte_eal/common/include/rte_pci.h b/lib/librte_eal/common/include/rte_pci.h
index a346532..b4f38bc 100644
--- a/lib/librte_eal/common/include/rte_pci.h
+++ b/lib/librte_eal/common/include/rte_pci.h
@@ -239,10 +239,10 @@ do {                                                               \
  * a domain prefix (i.e. domain returned is always 0)
  *
  * @param input
- * 	The input string to be parsed. Should have the format XX:XX.X
+ *	The input string to be parsed. Should have the format XX:XX.X
  * @param dev_addr
- * 	The PCI Bus-Device-Function address to be returned. Domain will always be
- * 	returned as 0
+ *	The PCI Bus-Device-Function address to be returned. Domain will always be
+ *	returned as 0
  * @return
  *  0 on success, negative on error.
  */
@@ -262,9 +262,9 @@ eal_parse_pci_BDF(const char *input, struct rte_pci_addr *dev_addr)
  * a domain prefix.
  *
  * @param input
- * 	The input string to be parsed. Should have the format XXXX:XX:XX.X
+ *	The input string to be parsed. Should have the format XXXX:XX:XX.X
  * @param dev_addr
- * 	The PCI Bus-Device-Function address to be returned
+ *	The PCI Bus-Device-Function address to be returned
  * @return
  *  0 on success, negative on error.
  */
diff --git a/lib/librte_eal/linuxapp/eal/Makefile b/lib/librte_eal/linuxapp/eal/Makefile
index 077ea99..e99d7a3 100644
--- a/lib/librte_eal/linuxapp/eal/Makefile
+++ b/lib/librte_eal/linuxapp/eal/Makefile
@@ -119,4 +119,3 @@ SYMLINK-$(CONFIG_RTE_LIBRTE_EAL_LINUXAPP)-include/exec-env := \
 DEPDIRS-$(CONFIG_RTE_LIBRTE_EAL_LINUXAPP) += lib/librte_eal/common
 
 include $(RTE_SDK)/mk/rte.lib.mk
-
diff --git a/lib/librte_eal/linuxapp/eal/eal_interrupts.c b/lib/librte_eal/linuxapp/eal/eal_interrupts.c
index 3a84b3c..a6325c6 100644
--- a/lib/librte_eal/linuxapp/eal/eal_interrupts.c
+++ b/lib/librte_eal/linuxapp/eal/eal_interrupts.c
@@ -894,4 +894,3 @@ rte_eal_intr_init(void)
 
 	return -ret;
 }
-
diff --git a/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c b/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c
index 543bf57..bfe0af8 100644
--- a/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c
+++ b/lib/librte_eal/linuxapp/xen_dom0/dom0_mm_misc.c
@@ -463,7 +463,7 @@ dom0_memory_reserve(uint32_t rsv_size)
 	}
 
 	sort_viraddr(rsv_mm_info, num_block);
-	
+
 	for (i = 0; i< num_block; i++) {
 
 		/*